org.apache.commons.net.imap

## Class IMAP

- java.lang.Object
- - org.apache.commons.net.SocketClient
  - - org.apache.commons.net.imap.IMAP

- Direct Known Subclasses:
    IMAPClient

      public class IMAP
      extends SocketClient

  The IMAP class provides the basic the functionality necessary to implement your own IMAP client.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static interface` | `IMAP.IMAPChunkListener` Implement this interface and register it via `setChunkListener(IMAPChunkListener)` in order to get access to multi-line partial command responses.
    `static class` | `IMAP.IMAPState` Enumerates IMAP states.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected static String` | `__DEFAULT_ENCODING` The default control socket encoding.
    `protected BufferedWriter` | `__writer` Buffered writer.
    `protected BufferedReader` | `_reader` Buffered reader.
    `static int` | `DEFAULT_PORT` The default IMAP port (RFC 3501).
    `static IMAP.IMAPChunkListener` | `TRUE_CHUNK_LISTENER` Implements `IMAP.IMAPChunkListener` to returns `true` but otherwise does nothing.

    - ### Fields inherited from class org.apache.commons.net.SocketClient

      `_defaultPort_, _hostname_, _input_, _output_, _serverSocketFactory_, _socket_, _socketFactory_, _timeout_, connectTimeout, NETASCII_EOL, remoteInetSocketAddress`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `IMAP()` The default IMAPClient constructor.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `_connectAction_()` Performs connection initialization and sets state to `IMAP.IMAPState.NOT_AUTH_STATE`.
    `void` | `disconnect()` Disconnects the client from the server, and sets the state to `DISCONNECTED_STATE`.
    `boolean` | `doCommand(IMAPCommand command)` Sends a command to the server and return whether successful.
    `boolean` | `doCommand(IMAPCommand command, String args)` Sends a command and arguments to the server and return whether successful.
    `protected void` | `fireReplyReceived(int replyCode, String ignored)` Overrides `SocketClient.fireReplyReceived(int, String)` to avoid creating the reply string if there are no listeners to invoke.
    `protected String` | `generateCommandID()` Generates a new command ID (tag) for a command.
    `String` | `getReplyString()` Gets the reply to the last command sent to the server.
    `String[]` | `getReplyStrings()` Gets an array of lines received as a reply to the last command sent to the server.
    `IMAP.IMAPState` | `getState()` Gets the current IMAP client state.
    `(package private) static String` | `quoteMailboxName(String input)` Quote an input string if necessary.
    `int` | `sendCommand(IMAPCommand command)` Sends a command with no arguments to the server and returns the reply code.
    `int` | `sendCommand(IMAPCommand command, String args)` Sends a command and arguments to the server and returns the reply code.
    `int` | `sendCommand(String command)` Sends a command with no arguments to the server and returns the reply code.
    `int` | `sendCommand(String command, String args)` Sends a command an arguments to the server and returns the reply code.
    `int` | `sendData(String command)` Sends data to the server and returns the reply code.
    `void` | `setChunkListener(IMAP.IMAPChunkListener listener)` Sets the current chunk listener.
    `protected void` | `setState(IMAP.IMAPState state)` Sets IMAP client state.

    - ### Methods inherited from class org.apache.commons.net.SocketClient

      `addProtocolCommandListener, applySocketAttributes, checkOpenOutputStream, connect, connect, connect, connect, connect, connect, createCommandSupport, fireCommandSent, getCharset, getCommandSupport, getConnectTimeout, getDefaultPort, getDefaultTimeout, getHostAddress, getHostAddress, getKeepAlive, getLocalAddress, getLocalPort, getProxy, getReceiveBufferSize, getRemoteAddress, getRemoteInetSocketAddress, getRemotePort, getSendBufferSize, getServerSocketFactory, getSoLinger, getSoTimeout, getTcpNoDelay, isAvailable, isConnected, removeProtocolCommandListener, setCharset, setConnectTimeout, setDefaultPort, setDefaultTimeout, setKeepAlive, setProxy, setReceiveBufferSize, setSendBufferSize, setServerSocketFactory, setSocketFactory, setSoLinger, setSoTimeout, setTcpNoDelay, verifyRemote`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### __DEFAULT_ENCODING

          protected static final String __DEFAULT_ENCODING

      The default control socket encoding.

    - #### __writer

          protected BufferedWriter __writer

      Buffered writer.

    - #### _reader

          protected BufferedReader _reader

      Buffered reader.

    - #### DEFAULT_PORT

          public static final int DEFAULT_PORT

      The default IMAP port (RFC 3501).
      See Also:
        Constant Field Values

    - #### TRUE_CHUNK_LISTENER

          public static final IMAP.IMAPChunkListener TRUE_CHUNK_LISTENER

      Implements `IMAP.IMAPChunkListener` to returns `true` but otherwise does nothing.

      This is intended for use with a suitable ProtocolCommandListener. If the IMAP response contains multiple-line data, the protocol listener will be called for each multi-line chunk. The accumulated reply data will be cleared after calling the listener. If the response is very long, this can significantly reduce memory requirements. The listener will also start receiving response data earlier, as it does not have to wait for the entire response to be read.

      The ProtocolCommandListener must be prepared to accept partial responses. This should not be a problem for listeners that just log the input.

      See Also:
        `setChunkListener(IMAPChunkListener)`

  - ### Constructor Detail

    - #### IMAP

          public IMAP()

      The default IMAPClient constructor. Initializes the state to `DISCONNECTED_STATE`.

  - ### Method Detail

    - #### _connectAction_

          protected void _connectAction_()
                                  throws IOException

      Performs connection initialization and sets state to `IMAP.IMAPState.NOT_AUTH_STATE`.
      Overrides:
        `_connectAction_` in class `SocketClient`
      Throws:
        `IOException` - (SocketException) if a problem occurs with the socket

    - #### disconnect

          public void disconnect()
                          throws IOException

      Disconnects the client from the server, and sets the state to `DISCONNECTED_STATE`. The reply text information from the last issued command is voided to allow garbage collection of the memory used to store that information.
      Overrides:
        `disconnect` in class `SocketClient`
      Throws:
        `IOException` - If there is an error in disconnecting.

    - #### doCommand

          public boolean doCommand(IMAPCommand command)
                            throws IOException

      Sends a command to the server and return whether successful.
      Parameters:
        `command` - The IMAP command to send (one of the IMAPCommand constants).
      Returns:
        `true` if the command was successful
      Throws:
        `IOException` - on error

    - #### doCommand

          public boolean doCommand(IMAPCommand command,
                                   String args)
                            throws IOException

      Sends a command and arguments to the server and return whether successful.
      Parameters:
        `command` - The IMAP command to send (one of the IMAPCommand constants).
        `args` - The command arguments.
      Returns:
        `true` if the command was successful
      Throws:
        `IOException` - on error

    - #### fireReplyReceived

          protected void fireReplyReceived(int replyCode,
                                           String ignored)

      Overrides `SocketClient.fireReplyReceived(int, String)` to avoid creating the reply string if there are no listeners to invoke.
      Overrides:
        `fireReplyReceived` in class `SocketClient`
      Parameters:
        `replyCode` - passed to the listeners
        `ignored` - the string is only created if there are listeners defined.
      See Also:
        `getReplyString()`

    - #### generateCommandID

          protected String generateCommandID()

      Generates a new command ID (tag) for a command.
      Returns:
        a new command ID (tag) for an IMAP command.

    - #### getReplyString

          public String getReplyString()

      Gets the reply to the last command sent to the server. The value is a single string containing all the reply lines including newlines.
      Returns:
        The last server response.

    - #### getReplyStrings

          public String[] getReplyStrings()

      Gets an array of lines received as a reply to the last command sent to the server. The lines have end of lines truncated.
      Returns:
        The last server response.

    - #### getState

          public IMAP.IMAPState getState()

      Gets the current IMAP client state.
      Returns:
        The current IMAP client state.

    - #### quoteMailboxName

          static String quoteMailboxName(String input)

      Quote an input string if necessary. If the string is enclosed in double-quotes it is assumed to be quoted already and is returned unchanged. If it is the empty string, "" is returned. If it contains a space then it is enclosed in double quotes, escaping the characters backslash and double-quote.
      Parameters:
        `input` - the value to be quoted, may be null
      Returns:
        the quoted value

    - #### sendCommand

          public int sendCommand(IMAPCommand command)
                          throws IOException

      Sends a command with no arguments to the server and returns the reply code.
      Parameters:
        `command` - The IMAP command to send (one of the IMAPCommand constants).
      Returns:
        The server reply code (see IMAPReply).
      Throws:
        `IOException` - on error

    - #### sendCommand

          public int sendCommand(IMAPCommand command,
                                 String args)
                          throws IOException

      Sends a command and arguments to the server and returns the reply code.
      Parameters:
        `command` - The IMAP command to send (one of the IMAPCommand constants).
        `args` - The command arguments.
      Returns:
        The server reply code (see IMAPReply).
      Throws:
        `IOException` - on error

    - #### sendCommand

          public int sendCommand(String command)
                          throws IOException

      Sends a command with no arguments to the server and returns the reply code.
      Parameters:
        `command` - The IMAP command to send.
      Returns:
        The server reply code (see IMAPReply).
      Throws:
        `IOException` - on error

    - #### sendCommand

          public int sendCommand(String command,
                                 String args)
                          throws IOException

      Sends a command an arguments to the server and returns the reply code.
      Parameters:
        `command` - The IMAP command to send.
        `args` - The command arguments.
      Returns:
        The server reply code (see IMAPReply).
      Throws:
        `IOException` - on error

    - #### sendData

          public int sendData(String command)
                       throws IOException

      Sends data to the server and returns the reply code.
      Parameters:
        `command` - The IMAP command to send.
      Returns:
        The server reply code (see IMAPReply).
      Throws:
        `IOException` - on error

    - #### setChunkListener

          public void setChunkListener(IMAP.IMAPChunkListener listener)

      Sets the current chunk listener. If a listener is registered and the implementation returns true, then any registered `PrintCommandListener` instances will be invoked with the partial response and a status of `IMAPReply.PARTIAL` to indicate that the final reply code is not yet known.
      Parameters:
        `listener` - the class to use, or `null` to disable
      See Also:
        `TRUE_CHUNK_LISTENER`

    - #### setState

          protected void setState(IMAP.IMAPState state)

      Sets IMAP client state. This must be one of the `_STATE` constants.
      Parameters:
        `state` - The new state.